package application

import (
	"encoding/json"
	"fmt"
	"math/rand"
	// "github.com/google/uuid"
	"net/http"
	"strconv"
	"time"
	// "path"
	"sirlab.de/go/knowyt/game"
)

type PlayerInfo struct {
	Status   string `json:"status"`
	Authcode string `json:"authcode"`
}

func (app *Application) CreateGame(w http.ResponseWriter, r *http.Request) {
	name := r.URL.Query().Get("name")
	teamname := r.URL.Query().Get("teamname")

	authcode := ""
	rnd := rand.New(rand.NewSource(time.Now().UnixNano()))
	for i := 0; i < 6; i++ {
		authcode += strconv.Itoa(rnd.Intn(1000) / 10 % 10)
	}

	gm, err := app.createGame(teamname)
	if err != nil {
		w.WriteHeader(http.StatusInternalServerError)
		fmt.Printf("%v\n", err)
		fmt.Fprintf(w, "server error")
		return
	}

	_, err = app.createUser(gm, name, authcode)
	if err != nil {
		w.WriteHeader(http.StatusInternalServerError)
		fmt.Printf("%v\n", err)
		fmt.Fprintf(w, "server error")
		return
	}

	playerInfo := PlayerInfo{
		Status:   "ok",
		Authcode: authcode,
	}
	fmt.Printf("Name %s, Teamname %s, Authcode %s\n", name, teamname, authcode)

	w.Header().Add("Content-Type", "application/json")
	jsonString, _ := json.Marshal(playerInfo)
	fmt.Fprintf(w, string(jsonString))
}

func (app *Application) createGame(gamename string) (*game.Game, error) {
	return nil, fmt.Errorf("createGame() not yet implemented")
}
